
// -----------------------------------------------------
// 初期セット
// -----------------------------------------------------
function SetStart() {

	try {
		document.inputForm.nUSER_NAME.focus();
		SetDefKensaDay();
		CalcWeek();
		SetPlanimeterStates();
		LoadCookie();
		CalcCpi();
		
	} catch( e ) {
		alert('エラ－:SetStart');
	}

}

// -----------------------------------------------------
// クッキー情報の読み込みとセット（XFDとTFD）
// -----------------------------------------------------
function LoadCookie() {

	try {
		var cs = document.cookie.split(';');

		cs.forEach(function(value) {
			var c = value.split('=');//cookie名と値に分ける
			
			if ( c[0].trim() == 'XFD' ) {
				document.inputForm.nXFD.value = c[1].trim();
			} else if ( c[0].trim() == 'TFD' ) {
				document.inputForm.nTFD.value = c[1].trim();
			}
			
		})

	} catch( e ) {
		alert('エラ－:LoadCookie');
	}

}

// -----------------------------------------------------
// クッキー情報の保存（XFD）
// -----------------------------------------------------
function SaveCookieXFD() {

	try {
		var limitDay = 3650;
		var limitDate = new Date();
		limitDate.setTime(limitDate.getTime() + limitDay * 24 * 60 * 60 * 1000);
		var cookieLimitText = limitDate.toGMTString();
		document.cookie = 'XFD=' + document.inputForm.nXFD.value + ';expires=' + cookieLimitText;

	} catch( e ) {
		alert('エラ－:SaveCookieXFD');
	}

}

// -----------------------------------------------------
// クッキー情報の保存（TFD）
// -----------------------------------------------------
function SaveCookieTFD() {

	try {
		var limitDay = 3650;
		var limitDate = new Date();
		limitDate.setTime(limitDate.getTime() + limitDay * 24 * 60 * 60 * 1000);
		var cookieLimitText = limitDate.toGMTString();
		document.cookie = 'TFD=' + document.inputForm.nTFD.value + ';expires=' + cookieLimitText;;

	} catch( e ) {
		alert('エラ－:SaveCookieTFD');
	}

}

// -----------------------------------------------------
// 検査年月日として今日の日付をセット
// -----------------------------------------------------
function SetDefKensaDay() {

	try {
		var now = new Date(); 
		document.inputForm.nKENSA_YEAR.value = now.getFullYear();
		document.inputForm.nKENSA_MONTH.value = now.getMonth() + 1;
		document.inputForm.nKENSA_DAY.value = now.getDate();
		document.inputForm.nYOTEI_YEAR.value = now.getFullYear();

	} catch( e ) {
		// 手入力すればいいだけなので、エラーは表示しない
	}

}

// -----------------------------------------------------
// プラニメ－ターの使用有無状態を反映
// -----------------------------------------------------
function SetPlanimeterStates() {

	try {
		if ( document.inputForm.nPLANIMETER.checked == true ) {
			document.inputForm.nPS.style.display = "block";
			document.inputForm.nCS.style.display = "block";

			document.getElementById('iDIV_PS').style.display = "none";
			document.getElementById('iDIV_CS').style.display = "none";

			document.getElementById('iPS_DESCRIPTION').style.display = "none";
			document.getElementById('iCS_DESCRIPTION').style.display = "none";
		} else {
			document.inputForm.nPS.style.display = "none";
			document.inputForm.nCS.style.display = "none";

			document.getElementById('iDIV_PS').style.display = "block";
			document.getElementById('iDIV_CS').style.display = "block";

			document.getElementById('iPS_DESCRIPTION').style.display = "block";
			document.getElementById('iCS_DESCRIPTION').style.display = "block";

			CalcPS();
			CalcCS();
		}

	} catch( e ) {
		alert('エラ－SetPlanimeterStates：');
	}

}

// -----------------------------------------------------
// プラニメ－ターの不使用時のPSを計算
// -----------------------------------------------------
function CalcPS() {

	try {
		if ( document.inputForm.nPLANIMETER.checked == true ) { return; }

		var flagErr = false;
		if( document.inputForm.n2A.value == '' ) { flagErr = true; }
		if( document.inputForm.nB1.value == '' ) { flagErr = true; }
		if( document.inputForm.nB2.value == '' ) { flagErr = true; }
		if( isNaN( document.inputForm.n2A.value ) == true ) { flagErr = true; }
		if( isNaN( document.inputForm.nB1.value ) == true ) { flagErr = true; }
		if( isNaN( document.inputForm.nB2.value ) == true ) { flagErr = true; }

		if ( flagErr == true ) {
			document.getElementById('iDIV_PS').innerHTML = '未計算';
		} else {
			var aa = 1 * document.inputForm.n2A.value;
			var b1 = 1 * document.inputForm.nB1.value;
			var b2 = 1 * document.inputForm.nB2.value;
			var ps = Math.PI * (aa / 2) * ( ( b1 + b2 ) / 2 );
			ps = Math.round(10 * ps) / 10;
			document.getElementById('iDIV_PS').innerHTML = ps;
		}

	} catch( e ) {
		document.getElementById('iDIV_PS').innerHTML = 'エラ－';
	}

}

// -----------------------------------------------------
// プラニメ－ターの不使用時のCSを計算
// -----------------------------------------------------
function CalcCS() {

	try {
		if ( document.inputForm.nPLANIMETER.checked == true ) { return; }

		var flagErr = false;
		if( document.inputForm.n2C.value == '' ) { flagErr = true; }
		if( document.inputForm.n2D.value == '' ) { flagErr = true; }
		if( isNaN( document.inputForm.n2C.value ) == true ) { flagErr = true; }
		if( isNaN( document.inputForm.n2D.value ) == true ) { flagErr = true; }

		if ( flagErr == true ) {
			document.getElementById('iDIV_CS').innerHTML = '未計算';
		} else {
			var cc = 1 * document.inputForm.n2C.value;
			var dd = 1 * document.inputForm.n2D.value;
			var cs = Math.PI * (cc / 2) * (dd / 2);
			cs = Math.round(10 * cs) / 10;
			document.getElementById('iDIV_CS').innerHTML = cs;
		}

	} catch( e ) {
		document.getElementById('iDIV_CS').innerHTML = 'エラ－';
	}

}

// -----------------------------------------------------
// 検査年月日と分娩予定日から週数を計算
// -----------------------------------------------------
function CalcWeek() {

	try {
		var kensaYear = 1 * document.inputForm.nKENSA_YEAR.value;
		var kensaMonth = 1 * document.inputForm.nKENSA_MONTH.value;
		var kensaDay = 1 * document.inputForm.nKENSA_DAY.value;
		var yoteiYear = 1 * document.inputForm.nYOTEI_YEAR.value;
		var yoteiMonth = 1 * document.inputForm.nYOTEI_MONTH.value;
		var yoteiDay = 1 * document.inputForm.nYOTEI_DAY.value;
		
		if ( yoteiMonth != 0 && yoteiDay != 0) {
			//残日数を取得
			var kensaDate = new Date( kensaYear , kensaMonth - 1 , kensaDay );
			var yoteiDate = new Date( yoteiYear , yoteiMonth - 1 , yoteiDay );
			var msDiff = yoteiDate.getTime() - kensaDate.getTime();
			var daysDiff = Math.floor( msDiff / (1000 * 60 * 60 *24) );
			
			//経過
			// 妊娠 1ヶ月 =  0週- 3週6日目の期間
			// 妊娠 2ヶ月 =  4週- 7週6日目の期間
			// 妊娠 3ヶ月 =  8週-11週6日目の期間
			// 妊娠 4ヶ月 = 12週-15週6日目の期間
			// 妊娠 5ヶ月 = 16週-19週6日目の期間
			// 妊娠 6ヶ月 = 20週-23週6日目の期間
			// 妊娠 7ヶ月 = 24週-27週6日目の期間
			// 妊娠 8ヶ月 = 28週-31週6日目の期間
			// 妊娠 9ヶ月 = 32週-35週6日目の期間
			// 妊娠10ヶ月 = 36週-39週6日目の期間
			var keikaWeek = Math.floor( (280 - daysDiff) / 7 );
			var keikaDay = (280 - daysDiff) % 7;
			var keikaMonth = 1 + Math.floor( keikaWeek / 4 );

			if ( keikaWeek < 0 ) {
				var startDate = yoteiDate;
				startDate.setDate( startDate.getDate() - 280 );
				var startYear = startDate.getFullYear();
				var startMonth = startDate.getMonth() + 1;
				var startDay = startDate.getDate();
				document.getElementById('iDIV_WEEK').innerHTML = ''; // 検査日が0週0日(=' + startYear + '年' + startMonth + '月' + startDay + '日)以前のため計算できません';
			} else {
				document.getElementById('iDIV_WEEK').innerHTML = ' ： ' + keikaWeek + '週' + keikaDay + '日（' + keikaMonth + 'ヶ月目）';

			}

		} else {
			document.getElementById('iDIV_WEEK').innerHTML = ''; // 分娩予定日が未入力のため計算できません';
		}
	
	} catch( e ) {
		document.getElementById('iDIV_WEEK').innerHTML = 'エラー';
	}

}


// -----------------------------------------------------
// CPIの計算
// -----------------------------------------------------
function CalcCpi() {

	try {
		//初期セット
		PutCalcError('未計算');

		if ( document.inputForm.nSITA.value != '' && document.inputForm.nALPHA.value != '' ) { 

			if ( isNaN(document.inputForm.nSITA.value) == false && isNaN(document.inputForm.nALPHA.value) == false ) { 

				if ( 1 * document.inputForm.nSITA.value >= 90 && 1 * document.inputForm.nALPHA.value < 0 ) { 
				PutCalcError('計算不要');
				}

			}

		}

		//入力有無、数値かどうか、数値の範囲をチェックする
		if( document.inputForm.nXFD.value == '' ) { PutCalcError('XFD に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.nXFD.value ) == true ) { PutCalcError('XFD が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.nXFD.value < 50 || 1 * document.inputForm.nXFD.value > 200 ) { PutCalcError('XFD に範囲(50≦XFD≦200)を入力して下さい。'); return false; }

		if( document.inputForm.nTFD.value == '' ) { PutCalcError('TFD に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.nTFD.value ) == true ) { PutCalcError('TFD が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.nTFD.value < 2 || 1 * document.inputForm.nTFD.value > 20 ) { PutCalcError('TFD が不正です。範囲(2≦TFD≦20)を入力して下さい。'); return false; }

		if( document.inputForm.n2A.value == '' ) { PutCalcError('2a に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.n2A.value ) == true ) { PutCalcError('2a が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.n2A.value <= 0 || 1 * document.inputForm.n2A.value >= 40 ) { PutCalcError('2a が不正です。範囲(0＜2a＜40)を入力して下さい。'); return false; }

		if( document.inputForm.nB1.value == '' ) { PutCalcError('b1 に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.nB1.value ) == true ) { PutCalcError('b1 が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.nB1.value <= 0 || 1 * document.inputForm.nB1.value >= 20 ) { PutCalcError('b1 が不正です。範囲(0＜b1＜20)を入力して下さい。'); return false; }

		if( document.inputForm.nB2.value == '' ) { PutCalcError('b2 に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.nB2.value ) == true ) { PutCalcError('b2 が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.nB2.value <= 0 || 1 * document.inputForm.nB2.value >= 20 ) { PutCalcError('b2 が不正です。範囲(0＜b2＜20)を入力して下さい。'); return false; }

		if ( 1 * document.inputForm.nB1.value > 1 * document.inputForm.nB2.value ) {
			PutCalcError('b1≦b2 とする必要があります。');
			return false;
		}

		if( document.inputForm.nPLANIMETER.checked == true ) {
			if( document.inputForm.nPS.value == '' ) { PutCalcError('PS に半角数字を入力して下さい。'); return false; }
			if( isNaN( document.inputForm.nPS.value ) == true ) { PutCalcError('PS が不正です。半角数字を入力して下さい。'); return false; }
			if( 1 * document.inputForm.nPS.value <= 0 || 1 * document.inputForm.nPS.value >= 1200 ) { PutCalcError('PS が不正です。範囲(0＜PS＜1200)を入力して下さい。'); return false; }
		}

		if( document.inputForm.n2C.value == '' ) { PutCalcError('2c に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.n2C.value ) == true ) { PutCalcError('2c が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.n2C.value <= 0 || 1 * document.inputForm.n2C.value >= 40 ) { PutCalcError('2c が不正です。範囲(0＜2c＜40)を入力して下さい。'); return false; }

		if( document.inputForm.n2D.value == '' ) { PutCalcError('2d に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.n2D.value ) == true ) { PutCalcError('2d が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.n2D.value <= 0 || 1 * document.inputForm.n2D.value >= 40 ) { PutCalcError('2d が不正です。範囲(0＜2d＜40)を入力して下さい。'); return false; }

		if ( 1 * document.inputForm.n2C.value > 1 * document.inputForm.n2D.value ) {
			PutCalcError('c≦d とする必要があります。');
			return false;
		}

		if( document.inputForm.nPLANIMETER.checked == true ) {
			if( document.inputForm.nCS.value == '' ) { PutCalcError('CS に半角数字を入力して下さい。'); return false; }
			if( isNaN( document.inputForm.nCS.value ) == true ) { PutCalcError('CS が不正です。半角数字を入力して下さい。'); return false; }
			if( 1 * document.inputForm.nCS.value <= 0 || 1 * document.inputForm.nCS.value >= 1200 ) { PutCalcError('CS が不正です。範囲(0＜CS＜1200)を入力して下さい。'); return false; }
		}

		if( document.inputForm.nSITA.value == '' ) { PutCalcError('θ に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.nSITA.value ) == true ) { PutCalcError('θ が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.nSITA.value < 40 || 1 * document.inputForm.nSITA.value >= 180 ) { PutCalcError('θ が不正です。範囲(40≦θ＜180)を入力して下さい。'); return false; }

		if( document.inputForm.nALPHA.value == '' ) { PutCalcError('α に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.nALPHA.value ) == true ) { PutCalcError('α が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.nALPHA.value <= -10 || 1 * document.inputForm.nALPHA.value >= 10 ) { PutCalcError('α が不正です。範囲(-10＜α＜-10)を入力して下さい。'); return false; }

		if( document.inputForm.nBETA.value == '' ) { PutCalcError('β に半角数字を入力して下さい。'); return false; }
		if( isNaN( document.inputForm.nBETA.value ) == true ) { PutCalcError('β が不正です。半角数字を入力して下さい。'); return false; }
		if( 1 * document.inputForm.nBETA.value <= 0 || 1 * document.inputForm.nBETA.value >= 30 ) { PutCalcError('β が不正です。範囲(0＜β＜30)を入力して下さい。'); return false; }



		//step1 : 値を取得
		var xfd =  1 * document.inputForm.nXFD.value;
		var tfd =  1 * document.inputForm.nTFD.value;
		var aa = 1 * document.inputForm.n2A.value;
		var b1 = 1 * document.inputForm.nB1.value;
		var b2 = 1 * document.inputForm.nB2.value;
		var ps = 0;

		if( document.inputForm.nPLANIMETER.checked == true ) {
			ps = 1 * document.inputForm.nPS.value;
		} else {
			ps = Math.PI * (aa / 2) * ( ( b1 + b2 ) / 2 );
		}

		var cc = 1 * document.inputForm.n2C.value;
		var dd = 1 * document.inputForm.n2D.value;
		var cs = 0;

		if( document.inputForm.nPLANIMETER.checked == true ) {
			cs = 1 * document.inputForm.nCS.value;
		} else {
			cs = Math.PI * (cc / 2) * (dd / 2);
		}

		var sita = 1 * document.inputForm.nSITA.value;
		var alpha = 1 * document.inputForm.nALPHA.value;
		var beta = 1 * document.inputForm.nBETA.value;

		if( document.inputForm.nPLANIMETER.checked == true ) {
			ps = 1 * document.inputForm.nPS.value;
			cs = 1 * document.inputForm.nCS.value;
		} else {
			ps = Math.PI * (aa / 2) * ( ( b1 + b2 ) / 2 );
			cs = Math.PI * (cc / 2) * (dd / 2);
		}


		//step2 : θの補正
		if ( sita > 90 ) { sita = 90; }
		var sitarad = sita / 180 * Math.PI;


		//step3 : 諸数計算
		var a = aa / 2;
		b1 = b1 * Math.sin( sitarad );
		b2 = b2 * Math.sin( sitarad );
		ps = ps * Math.sin( sitarad );
		var c = cc / 2;
		var d = dd / 2;
		cs = cs;
		var A = Math.pow(Math.cos( sitarad ), 2) / Math.pow(c, 2) + Math.pow(Math.sin( sitarad ), 2) / Math.pow(d, 2);
		var B = Math.pow(Math.sin( sitarad ), 2) / Math.pow(c, 2) + Math.pow(Math.cos( sitarad ), 2) / Math.pow(d, 2);
		var C = ( 1 / Math.pow(c, 2)  - 1 / Math.pow(d, 2) ) * Math.sin( sitarad ) * Math.cos( sitarad );
		var b = ( b1 + b2 ) / 2;


		//step4 : k、K の計算
		var k = Math.pow(A / B, 0.5);
		var K = 1 / ( Math.pow(A * B, 0.5) - C );


		//step5 : type判定とpqの計算
		var type = '';
		var pq = 0;

		if ( k < b1 / a ) {
			type = 'Ⅰ';
			pq = k * Math.pow(a, 2);

		} else if ( b1 / a <= k && k <= Math.pow(b * b2, 0.5) / a ) {
			type = 'Ⅱ';
			
			var pq1 = k * Math.pow(a, 2);
			var pq2 = k * ( a / b2 ) * ( b1 / b2 );
			var pq3 = 1 - Math.pow( b1 / b2, 2 );
			var pq4 = 1 - Math.pow(k, 2) * Math.pow(a / b2, 2);
			pq = pq1 * Math.pow( pq2 + Math.pow( pq3 * pq4, 0.5), 2);

		} else if ( Math.pow(b * b2, 0.5) / a < k ) {
			type = 'Ⅲ';
			pq = Math.pow(b, 2) / k ;

		} else {
			PutCalcError('エラーk');

		}

		//step6 : CPIの計算
		var ers = Math.PI * ( K - c * d );
		var ses = Math.PI * ( a * b - pq);
		var cpi = ( cs + ers ) / ( ps - ses ) * 100;


		//step7 : α,βによる補正(FD**2)
		var fd = 1 - alpha / ( xfd - tfd - beta );
		cpi = cpi * Math.pow(fd, 2);


		//step8 : cpiの丸め
		cpi = Math.round(10 * cpi) / 10;


		//値のセット
		PutCalcValue('CPI = ' + cpi + '   (TYPE ' + type + ')');

	} catch( e ) {
		PutCalcError('エラーCPI');
	}

}

// -----------------------------------------------------
// 結果の出力
// -----------------------------------------------------
function PutCalcValue(text) {

	document.getElementById('iDIV_CALC').innerHTML = '<font class="cCALC_VALUE">' + text + '</font>';

}

function PutCalcError(text) {

	document.getElementById('iDIV_CALC').innerHTML = '<font class="cCALC_ERROR">' + text + '</font>';


}
